package edu.rice.cs.mm.sample.visitor;

import junit.framework.TestCase;

public class ToStringTest extends TestCase {
    private IASTVisitor v = ToStringVisitor.create();
    
    public void testNum() {
        Num n = new Num(5);
        assertEquals("5", v.apply(n));
        Num m = new Num(-2);
        assertEquals("-2", v.apply(m));
    }

    public void testVar() {
        Var x = new Var("x");
        assertEquals("x", v.apply(x));
        Var y = new Var("y");
        assertEquals("y", v.apply(y));
    }    

    public void testAdd() {
        Num n = new Num(5);
        Num m = new Num(-2);
        Var x = new Var("x");
        Var y = new Var("y");
 
        Add a = new Add(n,m);
        assertEquals("(5 + -2)", v.apply(a));
        a = new Add(m,n);
        assertEquals("(-2 + 5)", v.apply(a));

        a = new Add(x,y);
        assertEquals("(x + y)", v.apply(a));
        a = new Add(y,x);
        assertEquals("(y + x)", v.apply(a));

        a = new Add(x,n);
        assertEquals("(x + 5)", v.apply(a));
        a = new Add(n,x);
        assertEquals("(5 + x)", v.apply(a));

        a = new Add(x,n);
        assertEquals("(x + 5)", v.apply(a));
        a = new Add(n,x);
        assertEquals("(5 + x)", v.apply(a));

        a = new Add(y,m);
        assertEquals("(y + -2)", v.apply(a));
        a = new Add(m,y);
        assertEquals("(-2 + y)", v.apply(a));
    } 
}
