package edu.rice.cs.mm.sample.visitor;

import edu.rice.cs.mm.*;

public class ToStringVisitor implements IASTVisitor {
    public static IASTVisitor create() { 
        IASTVisitor v = new ToStringVisitor();
        v.proxy = MMProxy.newInstance(v);
        return v.proxy;
    }
    private IASTVisitor proxy;
    
    public String apply(IAST ast) {
        throw new AssertionError("Should never happen.");
    }
    public String apply(Num ast) {
        return String.valueOf(ast.getNum());
    }
    public String apply(Var ast) {
        return ast.getVar();
    }
    public String apply(Add ast) {
        return "("+proxy.apply(ast.getLeft())+" + "+proxy.apply(ast.getRight())+")";
    }
    public String apply(Mul ast) {
        return "("+proxy.apply(ast.getLeft())+" * "+proxy.apply(ast.getRight())+")";
    }
}
